package com.huangx.dubbo.consumer;

import com.huangx.dubbo.service.HelloService;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import java.util.HashMap;
import java.util.Map;


/**
 * 加载 Spring 配置，启动 Dubbo 服务消费者
 */
public class Consumer1 {

	public static void main(String[] args) throws Exception {
		Map<String,Integer> callCount = new HashMap<String, Integer>();
		try {
			ClassPathXmlApplicationContext context = new ClassPathXmlApplicationContext(new String[]{"dubbo-consumer.xml"});
			context.start();

			// 获取远程服务
			HelloService demoService = (HelloService) context.getBean("helloService");
			int i = 12;
			while (i > 0) {
				String value = demoService.sayHello("Bill");
				System.out.println(demoService.sayHello("Bill"));

				// 统计调用个数
				Integer count = callCount.get(value);
				if(null == count) {
					count = new Integer(1);
				} else {
					count += 1;
				}
				callCount.put(value, count);

				i--;
			}
		} finally {
			System.out.println("\n\n调用结果统计：");
			System.out.println("--------------------------------------------------");
			for(Map.Entry<String,Integer> entry : callCount.entrySet()) {
				System.out.println(entry.getKey() + " ======== " + entry.getValue());
			}
			System.out.println("\n");
		}
	}

}
